/* foXcommander - foXdesktop file manager
 * Copyright (C) 2000-2001 Josua Groeger derived from XWC (C) 1999-2000 Maxim Baranov
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include "FDCApplicationsFoXcommander.h"

FDCIMPLEMENT (FDCApplicationsFoXcommander, FDComponent, NULL, 0);

FDCApplicationsFoXcommander::FDCApplicationsFoXcommander (FDCARGS): FDComponent ("foXcontrol", "ApplicationsFoXcommander", FDCPARAMS)
{
  FXGroupBox *groupBox= new FXGroupBox (this, "Preferences",
                                        LAYOUT_CENTER_X|LAYOUT_CENTER_Y|GROUPBOX_TITLE_LEFT|FRAME_THICK);
  FXVerticalFrame *contentsFrame= new FXVerticalFrame (groupBox);

  confirmDeleteButton  = new FXCheckButton (contentsFrame, "Confirm de&lete");
  alwaysAskButton      = new FXCheckButton (contentsFrame, "Always as&k before file operation");
  showToolbarButton    = new FXCheckButton (contentsFrame, "Show &Toolbar");
  twoPanelsButton      = new FXCheckButton (contentsFrame, "Two &panels");
  showStatusbarButton  = new FXCheckButton (contentsFrame, "Show &Statusbar");
  showTreeButton       = new FXCheckButton (contentsFrame, "Show Tr&ee");
  showHiddenFilesButton= new FXCheckButton (contentsFrame, "Show h&idden files");

  foXcommanderRegistry= new FXRegistry ("foXcommander", "foXdesktop");
}

FDCApplicationsFoXcommander::~FDCApplicationsFoXcommander ()
{
  delete foXcommanderRegistry;
}

void FDCApplicationsFoXcommander::read ()
{
  foXcommanderRegistry->read ();

  confirmDeleteButton->setCheck (foXcommanderRegistry->readUnsignedEntry ("OPTIONS", "confirm_delete", true));
  alwaysAskButton->setCheck     (foXcommanderRegistry->readUnsignedEntry ("OPTIONS", "ask_before_copy", true));
  showToolbarButton->setCheck   (foXcommanderRegistry->readUnsignedEntry ("OPTIONS", "toolbar", true));
  twoPanelsButton->setCheck     (foXcommanderRegistry->readUnsignedEntry ("OPTIONS", "two_panels", false));
  showStatusbarButton->setCheck (foXcommanderRegistry->readUnsignedEntry ("OPTIONS", "statusbar", true));
  showTreeButton->setCheck      (foXcommanderRegistry->readUnsignedEntry ("OPTIONS", "show_tree", true));
  showHiddenFilesButton->setCheck (foXcommanderRegistry->readUnsignedEntry ("OPTIONS", "hidden_files", false));
}

void FDCApplicationsFoXcommander::write ()
{
  foXcommanderRegistry->writeUnsignedEntry ("OPTIONS","confirm_delete" , confirmDeleteButton->getCheck());
  foXcommanderRegistry->writeUnsignedEntry ("OPTIONS","ask_before_copy", alwaysAskButton->getCheck());
  foXcommanderRegistry->writeUnsignedEntry ("OPTIONS","toolbar"        , showToolbarButton->getCheck());
  foXcommanderRegistry->writeUnsignedEntry ("OPTIONS","two_panels"     , twoPanelsButton->getCheck());
  foXcommanderRegistry->writeUnsignedEntry ("OPTIONS","statusbar"      , showStatusbarButton->getCheck());
  foXcommanderRegistry->writeUnsignedEntry ("OPTIONS","show_tree"      , showTreeButton->getCheck());
  foXcommanderRegistry->writeUnsignedEntry ("OPTIONS","hidden_files"   , showHiddenFilesButton->getCheck());

  foXcommanderRegistry->write ();
}

void FDCApplicationsFoXcommander::defaults ()
{
  confirmDeleteButton->setCheck   (true);
  alwaysAskButton->setCheck       (true);
  showToolbarButton->setCheck     (true);
  twoPanelsButton->setCheck       (false);
  showStatusbarButton->setCheck   (true);
  showTreeButton->setCheck        (true);
  showHiddenFilesButton->setCheck (false);
}

void FDCApplicationsFoXcommander::about ()
{
  ((FDApp*) getApp ())->showAbout (this, "foXcommander", VERSION,
                                   "foXdesktop file manager", "foXcommander.xpm",
                                   "(C) 2000-2001 Josua Groeger <fractalus@gmx.net> derived from\n"
                                   "XWC (C) 1999-2000 Maxim Baranov <m_baranov@yahoo.com>",
                                   "http://foxdesktop.sourceforge.net");
}

void FDCApplicationsFoXcommander::help ()
{
  ((FDApp*) getApp ())->showHelp ("foXcommander", "preferences.html");
}
