/* foXcommander - foXdesktop file manager
 * Copyright (C) 2000-2001 Josua Groeger derived from XWC (C) 1999-2000 Maxim Baranov
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include <fox/xincs.h>
#include <fox/fx.h>
#include <fox/fxkeys.h>
#include "Panel.h"
#include "FDAppMainWindow.h"
#include "HistInputDialog.h"
#include "Attributes.h"
#include "icons.h"
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>

class RButtonMenuCmd : public FXMenuCommand {
    FXDECLARE(RButtonMenuCmd)
protected:
    RButtonMenuCmd(){};
public:
    RButtonMenuCmd(FXComposite* p,const FXString& text,FXIcon* ic=NULL,FXObject* tgt=NULL,FXSelector sel=0,FXuint opts=0);
};
// Map
FXDEFMAP( RButtonMenuCmd)  RButtonMenuCmdMap[]={
  FXMAPFUNC(SEL_RIGHTBUTTONPRESS,0,FXMenuCommand::onLeftBtnPress),
  FXMAPFUNC(SEL_RIGHTBUTTONRELEASE,0,FXMenuCommand::onLeftBtnRelease),
};
// Object implementation
FXIMPLEMENT(RButtonMenuCmd,FXMenuCommand,RButtonMenuCmdMap,ARRAYNUMBER(RButtonMenuCmdMap))
RButtonMenuCmd::RButtonMenuCmd(FXComposite* p,const FXString& text,FXIcon* ic,FXObject* tgt,FXSelector sel,FXuint opts):
FXMenuCommand(p,text,ic,tgt,sel,opts){}

extern FXString homelocation;
extern char** args;

// Global Flags
extern FXString clipboard;
extern int numDragItems;
#ifndef OPEN_WITH_HIST_SIZE
#define OPEN_WITH_HIST_SIZE 30
#endif
extern char OpenHistory[OPEN_WITH_HIST_SIZE][100];
extern int OpenNum;

FXString lastdir;

FXString devs;
FXuint liststyle;

/*******************************************************************************/

/* Map */
FXDEFMAP(FDAppMainWindow) FDAppMainWindowMap[]={
  FXMAPFUNC(SEL_UPDATE,FDAppMainWindow::ID_DIR_BOX,FDAppMainWindow::onUpdDirBox),
  FXMAPFUNC(SEL_UPDATE,FDAppMainWindow::ID_SHOW_BIG_ICONS,FDAppMainWindow::onUpdShow),
  FXMAPFUNC(SEL_UPDATE,FDAppMainWindow::ID_SHOW_MINI_ICONS,FDAppMainWindow::onUpdShow),
  FXMAPFUNC(SEL_UPDATE,FDAppMainWindow::ID_SHOW_DETAILS,FDAppMainWindow::onUpdShow),
  FXMAPFUNC(SEL_COMMAND,FDAppMainWindow::ID_DIR_BOX,FDAppMainWindow::onCmdDirBox),
  FXMAPFUNC(SEL_COMMAND,FDAppMainWindow::ID_RUN,FDAppMainWindow::onCmdRun),
  FXMAPFUNC(SEL_COMMAND,FDAppMainWindow::ID_SELECT_ALL,FDAppMainWindow::onCmdSelect),
  FXMAPFUNC(SEL_COMMAND,FDAppMainWindow::ID_DESELECT_ALL,FDAppMainWindow::onCmdSelect),
  FXMAPFUNC(SEL_COMMAND,FDAppMainWindow::ID_SELECT_INVERSE,FDAppMainWindow::onCmdSelect),
  FXMAPFUNC(SEL_COMMAND,FDAppMainWindow::ID_FILE_COPY,FDAppMainWindow::onCmdFileCopy),
  FXMAPFUNC(SEL_COMMAND,FDAppMainWindow::ID_FILE_MOVE,FDAppMainWindow::onCmdFileCopy),
  FXMAPFUNC(SEL_COMMAND,FDAppMainWindow::ID_FILE_LINK,FDAppMainWindow::onCmdFileCopy),
  FXMAPFUNC(SEL_COMMAND,FDAppMainWindow::ID_FILE_SLINK,FDAppMainWindow::onCmdFileCopy),
  FXMAPFUNC(SEL_COMMAND,FDAppMainWindow::ID_QUIT,FDAppMainWindow::onQuit),
  FXMAPFUNC(SEL_COMMAND,FDAppMainWindow::ID_ABOUT,FDAppMainWindow::onCmdAbout),
  FXMAPFUNC(SEL_COMMAND,FDAppMainWindow::ID_HELP,FDAppMainWindow::onCmdHelp),
  FXMAPFUNC(SEL_COMMAND,FDAppMainWindow::ID_XTERM,FDAppMainWindow::onCmdXTerm),
  FXMAPFUNC(SEL_COMMAND,FDAppMainWindow::ID_FILE_ASSOC,FDAppMainWindow::onCmdFileAssoc),
  FXMAPFUNC(SEL_COMMAND,FDAppMainWindow::ID_MENU,FDAppMainWindow::onCmdMenu),
  FXMAPFUNC(SEL_COMMAND,FDAppMainWindow::ID_OPTIONS,FDAppMainWindow::onCmdOptions),
  FXMAPFUNC(SEL_COMMAND,FDAppMainWindow::ID_SHOW_BIG_ICONS,FDAppMainWindow::onCmdShow),
  FXMAPFUNC(SEL_COMMAND,FDAppMainWindow::ID_SHOW_MINI_ICONS,FDAppMainWindow::onCmdShow),
  FXMAPFUNC(SEL_COMMAND,FDAppMainWindow::ID_SHOW_DETAILS,FDAppMainWindow::onCmdShow),
  FXMAPFUNC(SEL_COMMAND,FDAppMainWindow::ID_BOOKMARK,FDAppMainWindow::onCmdBookmark),
  FXMAPFUNC(SEL_COMMAND,FDAppMainWindow::ID_ADD_BOOKMARK,FDAppMainWindow::onCmdBookmark),
  FXMAPFUNC(SEL_CLOSE,   0,                      FDAppMainWindow::onQuit),
  FXMAPFUNC(SEL_CLICKED,FDAppMainWindow::ID_DIRECTORYLIST,FDAppMainWindow::onCmdDirectory),

  FXMAPFUNC (SEL_COMMAND, FDAppMainWindow::ID_OPTIONS_CHANGED, FDAppMainWindow::onCmdOptionsChanged),
  FXMAPFUNC (SEL_COMMAND, FDAppMainWindow::ID_HIDE_TREE, FDAppMainWindow::onCmdHideTree),
  FXMAPFUNC (SEL_COMMAND, FDAppMainWindow::ID_TOGGLE_HIDDEN, FDAppMainWindow::onCmdToggleHidden)

};

/* Object implementation */
FXIMPLEMENT(FDAppMainWindow,FXMainWindow,FDAppMainWindowMap,ARRAYNUMBER(FDAppMainWindowMap))

/*******************************************************************************/
  
/* Make some windows */
FDAppMainWindow::FDAppMainWindow (FDApp *a, const FXString &name, FXIcon *ic= NULL, FXIcon *mi= NULL,
                  FXuint opts= DECOR_ALL, FXint x=0, FXint y=0, FXint w=0, FXint h=0):
         FXMainWindow (a, name, ic, mi, opts, x,y,w,h, 0,0)
{
  FXHotKey hotkey;

  bookmarks = new FXRecentFiles("bookmarks",this,ID_BOOKMARK);

  archicon=new FXGIFIcon(a,arch);
  attricon=new FXGIFIcon(a,attrib);

  // Menubar
  FXToolbarShell *menuShell= new FXToolbarShell (this);
  menubar= new FXMenubar (this, menuShell, LAYOUT_FILL_X|FRAME_RAISED);
  new FXToolbarGrip (menubar, menubar, FXMenubar::ID_TOOLBARGRIP);
 
  // Toolbar
  FXToolbarShell *toolShell= new FXToolbarShell (this);
  toolbar= new FXToolbar (this, toolShell, LAYOUT_FILL_X|FRAME_RAISED);
  new FXToolbarGrip (toolbar, toolbar, FXToolbar::ID_TOOLBARGRIP);
  

    // Main window interior
    FXSplitter *split=new FXSplitter(this,LAYOUT_FILL_X|LAYOUT_FILL_Y|SPLITTER_TRACKING);
    group1=new FXVerticalFrame(split,LAYOUT_FILL_Y, 0,0,225,0, 0,0,0,0,0,0);
    FXHorizontalFrame* splitter=new FXHorizontalFrame(split,LAYOUT_FILL_X|LAYOUT_FILL_Y|PACK_UNIFORM_WIDTH,0,0,0,0, 0,0,0,0);

    
    // Directory list on the left
//    new FXLabel(group1,"All Folders",NULL,JUSTIFY_LEFT|LAYOUT_TOP|LAYOUT_FILL_X|FRAME_SUNKEN);
    FXPacker *p = new FXHorizontalFrame(group1,JUSTIFY_LEFT|LAYOUT_FILL_X|FRAME_SUNKEN,0,0,0,0, 0,0,0,0);
    FXVerticalFrame *subgroup1=new FXVerticalFrame(group1,FRAME_SUNKEN|FRAME_THICK|LAYOUT_FILL_X|LAYOUT_FILL_Y,0,0,0,0, 0,0,0,0);
    dirlist=new FXDirList(subgroup1,0,this,ID_DIRECTORYLIST, LAYOUT_FILL_X|LAYOUT_FILL_Y| \
                          TREELIST_BROWSESELECT|TREELIST_SHOWS_LINES|TREELIST_SHOWS_BOXES);
    lab = new FXLabel(group1," ",NULL,JUSTIFY_LEFT|LAYOUT_FILL_X|FRAME_SUNKEN);
    new FXButton(p,"\tHide",new FXGIFIcon(a,small_x),this,FDAppMainWindow::ID_HIDE_TREE,BUTTON_TOOLBAR|FRAME_RAISED|LAYOUT_RIGHT);

    // File panels on the right
    lpanel=new Panel("LEFT PANEL",splitter);
    rpanel=new Panel("RIGHT PANEL",splitter);
    lpanel->Next(rpanel);
    rpanel->Next(lpanel);
    lpanel->focus();

    FXButton *btn = NULL;
    // Directory box
    dirbox=new FXDirBox(toolbar,0,this,ID_DIR_BOX,FRAME_SUNKEN|FRAME_THICK|LAYOUT_FIX_WIDTH|LAYOUT_CENTER_Y,0,0,200,0, 2,2, 2,2);
    // Spacer
    new FXFrame(toolbar,LAYOUT_TOP|LAYOUT_LEFT|LAYOUT_FIX_WIDTH|LAYOUT_FIX_HEIGHT,0,0,10,20);

    // Add some toolbar buttons
    btn = new FXButton(toolbar,"\tGo up (BackSpace)",new FXGIFIcon(a,dirup),lpanel->current,Panel::ID_DIRECTORY_UP,BUTTON_TOOLBAR|FRAME_RAISED);
    btn->addHotKey(KEY_BackSpace);

    new FXFrame(toolbar,LAYOUT_TOP|LAYOUT_LEFT|LAYOUT_FIX_WIDTH|LAYOUT_FIX_HEIGHT,0,0,10,20);
    btn = new FXButton(toolbar,"\tCopy to clipboard (Ctrl-C)",new FXGIFIcon(a,copy_clp),lpanel->current,Panel::ID_COPY_CLP,BUTTON_TOOLBAR|FRAME_RAISED|ICON_BEFORE_TEXT);
    hotkey = (0004<<16) | KEY_c;
    btn->addHotKey(hotkey);

    btn = new FXButton(toolbar,"\tCut to clipboard (Ctrl-X)",new FXGIFIcon(a,cut_clp),lpanel->current,Panel::ID_CUT_CLP,BUTTON_TOOLBAR|FRAME_RAISED|ICON_BEFORE_TEXT);
    hotkey = (0004<<16) | KEY_x;
    btn->addHotKey(hotkey);

    btn = new FXButton(toolbar,"\tPaste from clipboard (Ctrl-V)",new FXGIFIcon(a,paste_clp),lpanel->current,Panel::ID_PASTE_CLP,BUTTON_TOOLBAR|FRAME_RAISED|ICON_BEFORE_TEXT);
    hotkey = (0004<<16) | KEY_v;
    btn->addHotKey(hotkey);

    new FXFrame(toolbar,LAYOUT_FIX_WIDTH|LAYOUT_FIX_HEIGHT,0,0,10,20);

    btn = new FXButton(toolbar,"\tDelete selected files (F8)",new FXGIFIcon(a,filedelete),lpanel->current,Panel::ID_FILE_DEL,BUTTON_TOOLBAR|FRAME_RAISED|ICON_BEFORE_TEXT);
    btn->addHotKey(KEY_F8);
    // Spacer
    new FXFrame(toolbar,LAYOUT_TOP|LAYOUT_LEFT|LAYOUT_FIX_WIDTH|LAYOUT_FIX_HEIGHT,0,0,10,20);
    btn = new FXButton(toolbar,"\tRefresh (Ctrl-R)",new FXGIFIcon(a,reload),lpanel,Panel::ID_REFRESH,BUTTON_TOOLBAR|FRAME_RAISED);
    hotkey = (0004<<16) | KEY_r;
    btn->addHotKey(hotkey);

    btn = new FXButton(toolbar,"\tGo home (Ctrl-H)",new FXGIFIcon(a,home),lpanel->current,Panel::ID_GO_HOME,BUTTON_TOOLBAR|FRAME_RAISED);
    hotkey = (0004<<16) | KEY_h;
    btn->addHotKey(hotkey);

    btn = new FXButton(toolbar,"\tCreate new folder (F7)",new FXGIFIcon(a,newfolder),lpanel->current,Panel::ID_NEW_DIR,BUTTON_TOOLBAR|FRAME_RAISED);
    btn->addHotKey(KEY_F7);


    hideButton= new FXToggleButton (toolbar, "\tShow hidden files", "\tHide hidden files",
                        new FXGIFIcon(a,filehidden), new FXGIFIcon(a,fileshown),
                        this, ID_TOGGLE_HIDDEN, BUTTON_TOOLBAR|FRAME_RAISED);

    // Spacer
    new FXFrame(toolbar,LAYOUT_TOP|LAYOUT_LEFT|LAYOUT_FIX_WIDTH|LAYOUT_FIX_HEIGHT,0,0,10,20);
    btn = new FXButton(toolbar,"\tShow attributes of selected files (F9)",attricon,lpanel->current,Panel::ID_ATTRIB,BUTTON_TOOLBAR|FRAME_RAISED|ICON_BEFORE_TEXT);
    btn->addHotKey(KEY_F9);

    // Spacer
    new FXFrame(toolbar,LAYOUT_FIX_WIDTH|LAYOUT_FIX_HEIGHT,0,0,10,20);

    // Switch display modes
    new FXButton(toolbar,"\tBig icons",new FXGIFIcon(a,bigicons),this,ID_SHOW_BIG_ICONS,BUTTON_TOOLBAR|ICON_BEFORE_TEXT|FRAME_RAISED);
    new FXButton(toolbar,"\tBrief file list",new FXGIFIcon(a,smallicons),this,ID_SHOW_MINI_ICONS,BUTTON_TOOLBAR|ICON_BEFORE_TEXT|FRAME_RAISED);
    new FXButton(toolbar,"\tFull file list",new FXGIFIcon(a,details),this,ID_SHOW_DETAILS,BUTTON_TOOLBAR|ICON_BEFORE_TEXT|FRAME_RAISED);

    // Spacer
    new FXFrame(toolbar,LAYOUT_FIX_WIDTH|LAYOUT_FIX_HEIGHT,0,0,10,20);
    btn = new FXButton(toolbar,"\tQuit (F10)",a->ico().insert ("mini/foXquit.xpm"),this,FDAppMainWindow::ID_QUIT,BUTTON_TOOLBAR|ICON_BEFORE_TEXT|FRAME_RAISED);
    btn->addHotKey(KEY_F10);

    /* Menus */
    /* Left View Menu Pane */
    leftviewmenu=new FXMenuPane(this);
    new RButtonMenuCmd(leftviewmenu,"Filter\t\tShow files and directories that match  pattern.",NULL,lpanel,Panel::ID_FILTER);
    new FXMenuSeparator(leftviewmenu);
    new RButtonMenuCmd(leftviewmenu,"Full file list\t\tShow detail file list.",NULL,lpanel->list,FXIconList::ID_SHOW_DETAILS);
    new RButtonMenuCmd(leftviewmenu,"Brief file list\t\tShow brief file list.",NULL,lpanel->list,FXIconList::ID_SHOW_MINI_ICONS);
    new RButtonMenuCmd(leftviewmenu,"Big icons\t\tShow big icons.",NULL,lpanel->list,FXIconList::ID_SHOW_BIG_ICONS);
    new FXMenuSeparator(leftviewmenu);
    new RButtonMenuCmd(leftviewmenu,"Rows\t\tView row-wise.",NULL,lpanel->list,FXIconList::ID_ARRANGE_BY_ROWS);
    new RButtonMenuCmd(leftviewmenu,"Columns\t\tView column-wise.",NULL,lpanel->list,FXIconList::ID_ARRANGE_BY_COLUMNS);
    new FXMenuSeparator(leftviewmenu);
    new RButtonMenuCmd(leftviewmenu,"Name\t\tSort by file name.",NULL,lpanel->list,FXFileList::ID_SORT_BY_NAME);
    new RButtonMenuCmd(leftviewmenu,"Type\t\tSort by file type.",NULL,lpanel->list,FXFileList::ID_SORT_BY_TYPE);
    new RButtonMenuCmd(leftviewmenu,"Size\t\tSort by file size.",NULL,lpanel->list,FXFileList::ID_SORT_BY_SIZE);
    new RButtonMenuCmd(leftviewmenu,"Time\t\tSort by modification time.",NULL,lpanel->list,FXFileList::ID_SORT_BY_TIME);
    lmenutitle = new FXMenuTitle(menubar,"Left",NULL,leftviewmenu);

    /* Commands menu pane */
    FXMenuPane* commenu=new FXMenuPane(this);
    FXMenuPane* selmenu=new FXMenuPane(this);
    new FXMenuCommand(selmenu,"Select all\t\tSelect all icons",NULL,this,ID_SELECT_ALL);
    new FXMenuCommand(selmenu,"Deselect all\t\tDeselect all icons",NULL,this,ID_DESELECT_ALL);
    new FXMenuCommand(selmenu,"Invert selection\t\tInvert selection",NULL,this,ID_SELECT_INVERSE);

    new FXMenuCascade(commenu,"Selection",NULL,selmenu);
    new FXMenuSeparator(commenu);
    new FXMenuCommand(commenu,"Run\t\tRun command in background.",NULL,this,ID_RUN);
    new FXMenuCommand(commenu,"New folder\t\tCreate new folder.",NULL,lpanel->current,Panel::ID_NEW_DIR);
    new FXMenuCommand(commenu,"Go home\t\tCd to home folder.",NULL,lpanel->current,Panel::ID_GO_HOME);
    new FXMenuCommand(commenu,"XTerm\t\tRun XTerm here.",NULL,this,FDAppMainWindow::ID_XTERM);
    new FXMenuCommand(commenu,"Refresh",NULL,lpanel,Panel::ID_REFRESH);
    new FXMenuSeparator(commenu);
    new FXMenuCommand (commenu, "&Quit\tCtl-Q", a->ico().insert ("mini/foXquit.xpm"),
                       this, FDAppMainWindow::ID_QUIT, MENU_DEFAULT);

    new FXMenuTitle(menubar,"&Commands",NULL,commenu);

    /* Bookmarks menu */
    FXMenuPane* bookmarksmenu=new FXMenuPane(this);
    new FXMenuCommand(bookmarksmenu,"Add bookmark",NULL,this,ID_ADD_BOOKMARK);
    FXMenuSeparator* sep1=new FXMenuSeparator(bookmarksmenu);
    sep1->setTarget(bookmarks);
    sep1->setSelector(FXRecentFiles::ID_ANYFILES);

    new FXMenuCommand(bookmarksmenu," ",NULL,bookmarks,FXRecentFiles::ID_FILE_1);
    new FXMenuCommand(bookmarksmenu," ",NULL,bookmarks,FXRecentFiles::ID_FILE_2);
    new FXMenuCommand(bookmarksmenu,NULL,NULL,bookmarks,FXRecentFiles::ID_FILE_3);
    new FXMenuCommand(bookmarksmenu,NULL,NULL,bookmarks,FXRecentFiles::ID_FILE_4);
    new FXMenuCommand(bookmarksmenu,NULL,NULL,bookmarks,FXRecentFiles::ID_FILE_5);
    new FXMenuCommand(bookmarksmenu,NULL,NULL,bookmarks,FXRecentFiles::ID_FILE_6);
    new FXMenuCommand(bookmarksmenu,NULL,NULL,bookmarks,FXRecentFiles::ID_FILE_7);
    new FXMenuCommand(bookmarksmenu,NULL,NULL,bookmarks,FXRecentFiles::ID_FILE_8);
    new FXMenuCommand(bookmarksmenu,NULL,NULL,bookmarks,FXRecentFiles::ID_FILE_9);
    new FXMenuCommand(bookmarksmenu,NULL,NULL,bookmarks,FXRecentFiles::ID_FILE_10);
    
    /*new FXMenuCommand(bookmarksmenu,NULL,NULL,bookmarks,FXRecentFiles::ID_FILE_11);
    new FXMenuCommand(bookmarksmenu,NULL,NULL,bookmarks,FXRecentFiles::ID_FILE_12);
    new FXMenuCommand(bookmarksmenu,NULL,NULL,bookmarks,FXRecentFiles::ID_FILE_13);
    new FXMenuCommand(bookmarksmenu,NULL,NULL,bookmarks,FXRecentFiles::ID_FILE_14);
    new FXMenuCommand(bookmarksmenu,NULL,NULL,bookmarks,FXRecentFiles::ID_FILE_15);
    new FXMenuCommand(bookmarksmenu,NULL,NULL,bookmarks,FXRecentFiles::ID_FILE_16);
    new FXMenuCommand(bookmarksmenu,NULL,NULL,bookmarks,FXRecentFiles::ID_FILE_17);
    new FXMenuCommand(bookmarksmenu,NULL,NULL,bookmarks,FXRecentFiles::ID_FILE_18);
    new FXMenuCommand(bookmarksmenu,NULL,NULL,bookmarks,FXRecentFiles::ID_FILE_19);
    new FXMenuCommand(bookmarksmenu,NULL,NULL,bookmarks,FXRecentFiles::ID_FILE_20);*/


    sep1=new FXMenuSeparator(bookmarksmenu);
    sep1->setTarget(bookmarks);
    sep1->setSelector(FXRecentFiles::ID_ANYFILES);
    new FXMenuCommand(bookmarksmenu,"Clear bookmarks",NULL,bookmarks,FXRecentFiles::ID_CLEAR);
    new FXMenuTitle(menubar,"Bookmarks",NULL,bookmarksmenu);

    /* Options menu */
    FXMenuPane* viewmenu=new FXMenuPane(this);
    new FXMenuTitle(menubar,"&Settings",NULL,viewmenu);
    new FXMenuCommand(viewmenu,"&Preferences",NULL,this,FDAppMainWindow::ID_OPTIONS);

    /* Right View Menu Pane */
    rightviewmenu=new FXMenuPane(this);
    new RButtonMenuCmd(rightviewmenu,"Filter\t\tShow files and folders that match  pattern.",NULL,rpanel,Panel::ID_FILTER);
    new FXMenuSeparator(rightviewmenu);
    new RButtonMenuCmd(rightviewmenu,"Full file list\t\tShow detail file list.",NULL,rpanel->list,FXIconList::ID_SHOW_DETAILS);
    new RButtonMenuCmd(rightviewmenu,"Brief file list\t\tShow brief file list.",NULL,rpanel->list,FXIconList::ID_SHOW_MINI_ICONS);
    new RButtonMenuCmd(rightviewmenu,"Big icons\t\tShow big icons.",NULL,rpanel->list,FXIconList::ID_SHOW_BIG_ICONS);
    new FXMenuSeparator(rightviewmenu);
    new RButtonMenuCmd(rightviewmenu,"Rows\t\tView row-wise.",NULL,rpanel->list,FXIconList::ID_ARRANGE_BY_ROWS);
    new RButtonMenuCmd(rightviewmenu,"Columns\t\tView column-wise.",NULL,rpanel->list,FXIconList::ID_ARRANGE_BY_COLUMNS);
    new FXMenuSeparator(rightviewmenu);
    new RButtonMenuCmd(rightviewmenu,"Name\t\tSort by file name.",NULL,rpanel->list,FXFileList::ID_SORT_BY_NAME);
    new RButtonMenuCmd(rightviewmenu,"Type\t\tSort by file type.",NULL,rpanel->list,FXFileList::ID_SORT_BY_TYPE);
    new RButtonMenuCmd(rightviewmenu,"Size\t\tSort by file size.",NULL,rpanel->list,FXFileList::ID_SORT_BY_SIZE);
    new RButtonMenuCmd(rightviewmenu,"Time\t\tSort by modification time.",NULL,rpanel->list,FXFileList::ID_SORT_BY_TIME);
    rmenutitle = new FXMenuTitle(menubar,"Right",NULL,rightviewmenu);

    /* Help menu */
    FXMenuPane *helpMenu= new FXMenuPane (this);
    new FXMenuTitle (menubar, "&Help", NULL, helpMenu, LAYOUT_RIGHT);
    new FXMenuCommand (helpMenu, "&Contents\tF1", a->ico().insert ("mini/foXhelp.xpm"), this, ID_HELP);
    new FXMenuSeparator (helpMenu);
    new FXMenuCommand (helpMenu, "&About foXcommander...", a->ico().insert ("mini/foXcommander.xpm"),
                       this, ID_ABOUT, MENU_DEFAULT);

    /* Make a tool tip */
    new FXTooltip(a,0);

  // Preferences
  preferencesDialog= new FXDialogBox (this, "Preferences", DECOR_TITLE|DECOR_BORDER|PLACEMENT_OWNER,
                                      0,0,400,350, 0,0,0,0,0,0);
  constructDict= new FDComponentConstructDict ((FDApp*) getApp ());
  FXScrollWindow *scrollWindow= new FXScrollWindow (preferencesDialog, LAYOUT_FILL_X|LAYOUT_FILL_Y);

  constructDict->insert ("foXcontrol", "ApplicationsFoXcommander")
                        (scrollWindow, LAYOUT_FILL_X|LAYOUT_FILL_Y,
                         this, MKUINT (ID_OPTIONS_CHANGED, SEL_COMMAND), NULL,
                         preferencesDialog, MKUINT (FXDialogBox::ID_CANCEL, SEL_COMMAND), NULL,
                         0,0,0,0, 0,0,0,0);

}

FDAppMainWindow::~FDAppMainWindow ()
{
  delete constructDict;
}

/*******************************************************************************/
/* Handle quitting */
void FDAppMainWindow::saveConfig()
{
  getApp()->reg().writeStringEntry("LEFT PANEL","lastdir",lpanel->list->getDirectory().text());
  getApp()->reg().writeUnsignedEntry("LEFT PANEL","liststyle",lpanel->list->getListStyle());
  getApp()->reg().writeStringEntry("RIGHT PANEL","lastdir",rpanel->list->getDirectory().text());
  getApp()->reg().writeUnsignedEntry("RIGHT PANEL","liststyle",rpanel->list->getListStyle());
  getApp()->reg().writeUnsignedEntry("OPTIONS","status",(FXuint)lpanel->status->shown());

  FXString history="";
  for(int i=0;i<RunHistSize;i++)
  {
    history+=RunHistory[i];
    history+=":";
  }
  if(RunHistory) getApp()->reg().writeStringEntry("HISTORY","run",history.text());

  history="";
  for(int i=0;i<OpenNum;i++)
  {
    history+=OpenHistory[i];
    history+=":";
  }
  if(OpenNum) getApp()->reg().writeStringEntry("HISTORY","open",history.text());
  getApp()->reg().write();
}
long FDAppMainWindow::onQuit(FXObject*,FXSelector,void*)
{
  saveConfig();

  exit(0);
  return 1;
}
/*******************************************************************************/
/* Make application */
void FDAppMainWindow::create()
{
    FXMainWindow::create();

  onCmdOptionsChanged (this, 0, NULL);




     if(opendir)
        lastdir = opendir;
    else
        lastdir=getApp()->reg().readStringEntry("LEFT PANEL","lastdir",homelocation.text());

    liststyle=getApp()->reg().readUnsignedEntry("LEFT PANEL","liststyle",(FXuint)FXIconList::ID_SHOW_DETAILS);
    lpanel->list->setDirectory(lastdir);
    lpanel->label->setText(lastdir);
    lpanel->list->setListStyle(liststyle);
    dirlist->setDirectory(lastdir);

   lastdir=getApp()->reg().readStringEntry("RIGHT PANEL","lastdir",homelocation.text());
   liststyle=getApp()->reg().readUnsignedEntry("RIGHT PANEL","liststyle",(FXuint)FXIconList::ID_SHOW_DETAILS);   
   rpanel->list->setDirectory(lastdir);
   rpanel->label->setText(lastdir);
   rpanel->list->setListStyle(liststyle);    

   FXString history=getApp()->reg().readStringEntry("HISTORY","run","");
   FXString histent;
   

  int i;
  if(history != "")
   {
       for(i=0;;i++)
       {
           histent=history.extract(i,':');
           if(histent.text() == NULL) break;
           strcpy(RunHistory[i],histent.text());
       }
       RunHistSize=i;
   }
   else
   {
       RunHistSize=0;
   }

   history=getApp()->reg().readStringEntry("HISTORY","open","");
   histent="";
   if(history != "")
   {
       for(i=0;;i++)
       {
           histent=history.extract(i,':');
           if(histent.text() == NULL) break;
           strcpy(OpenHistory[i],histent.text());
       }
       OpenNum=i;
   }
   else
   {
       OpenNum=0;
   }

   getApp()->forceRefresh();
   show();
}

long  FDAppMainWindow::onCmdBookmark(FXObject* o,FXSelector s,void* p)
{
    if(SELID(s) == ID_ADD_BOOKMARK)
        bookmarks->appendFile(lpanel->current->list->getDirectory());
    else if(SELID(s) == ID_BOOKMARK)
        lpanel->current->list->setDirectory((FXchar*)p);
    return 1;
}
/*******************************************************************************/
/* Run Terminal */
long  FDAppMainWindow::onCmdXTerm(FXObject*,FXSelector,void*)
{
    chdir(lpanel->current->list->getDirectory().text());
    FXString cmd (getApp ()->reg ().readStringEntry ("PROGRAM ALIASES", "xterm", fd_default_xterm));
    cmd += " &";
    system(cmd.text());
    //    chdir()
    lpanel->current->list->setFocus();
    return 0;
}
/*******************************************************************************/

long FDAppMainWindow::onCmdAbout (FXObject*, FXSelector, void*)
{
  ((FDApp*) getApp ())->showAbout (this, "foXcommander", VERSION,
                                   "foXdesktop file manager", "foXcommander.xpm",
                                   "(C) 2000-2001 Josua Groeger <fractalus@gmx.net> derived from\n"
                                   "XWC (C) 1999-2000 Maxim Baranov <m_baranov@yahoo.com>",
                                   "http://foxdesktop.sourceforge.net");
  return 1;
}

long FDAppMainWindow::onCmdHelp (FXObject*, FXSelector, void*)
{
  ((FDApp*) getApp ())->showHelp ("foXcommander");
  return 1;
}

/*******************************************************************************/
long FDAppMainWindow::onUpdShow(FXObject* sender,FXSelector sel,void* ptr)
{
    FXuint msg = FXWindow::ID_UNCHECK;
    FXuint style = lpanel->current->list->getListStyle() & ~ICONLIST_COLUMNS;
    switch(SELID(sel))
    {
    case ID_SHOW_BIG_ICONS:
        if(style == ICONLIST_BIG_ICONS)
            msg = FXWindow::ID_CHECK;
        break;
    case ID_SHOW_MINI_ICONS:
        if(style == ICONLIST_MINI_ICONS)
            msg = FXWindow::ID_CHECK;
        break;
    case ID_SHOW_DETAILS:
        if(style == ICONLIST_DETAILED)
            msg = FXWindow::ID_CHECK;
        break;
    }
    sender->handle(this,MKUINT(msg,SEL_COMMAND),ptr);
    //handle(sender,MKUINT(ID_BUTTON_STYLE,SEL_UPDATE),NULL);
    return 1;
}
long FDAppMainWindow::onCmdShow(FXObject* sender,FXSelector sel,void* ptr)
{
    switch(SELID(sel))
    {
    case ID_SHOW_BIG_ICONS:
        lpanel->current->list->handle(sender,MKUINT(FXFileList::ID_SHOW_BIG_ICONS,SEL_COMMAND),ptr);
        break;
    case ID_SHOW_MINI_ICONS:
        lpanel->current->list->handle(sender,MKUINT(FXFileList::ID_SHOW_MINI_ICONS,SEL_COMMAND),ptr);
        break;
    case ID_SHOW_DETAILS:
        lpanel->current->list->handle(sender,MKUINT(FXFileList::ID_SHOW_DETAILS,SEL_COMMAND),ptr);
        break;
    }
    return 1;
}
long FDAppMainWindow::onCmdSelect(FXObject* sender,FXSelector sel,void* ptr)
{
    switch(SELID(sel))
    {
    case ID_SELECT_ALL:
        lpanel->current->list->handle(sender,MKUINT(FXFileList::ID_SELECT_ALL,SEL_COMMAND),ptr);
        return 1;
    case ID_DESELECT_ALL:
        lpanel->current->list->handle(sender,MKUINT(FXFileList::ID_DESELECT_ALL,SEL_COMMAND),ptr);
        return 1;
    case ID_SELECT_INVERSE:
        lpanel->current->list->handle(sender,MKUINT(FXFileList::ID_SELECT_INVERSE,SEL_COMMAND),ptr);
        return 1;
    }
    printf("not founs\n");
    return 1;
}

long FDAppMainWindow::onCmdMenu(FXObject *o,FXSelector s,void *p)
{
    // Popup menu pane
    static FXMenuPane *menu = NULL;
    if(menu)
        delete menu;
    menu = new FXMenuPane(this);
    FXint x,y; FXuint state;
    
    getRoot()->getCursorPosition(x,y,state);

    
    
    int num= 0, itm= -1;
    for (int u= 0; u< lpanel->current->list->getNumItems (); u++)
      if (lpanel->current->list->isItemSelected (u))
      {
        if (itm== -1) itm= u;
        num++;
      }
    
    //int num = lpanel->current->list->getNumSelectedItems();
    
    // menu depends on num of selected items

    if(num == 0)// no selection
    {
        new RButtonMenuCmd(menu,"Filter\t\tShow files and folders that match  pattern.",NULL,rpanel->current,Panel::ID_FILTER);
        new FXMenuSeparator(menu);
        new RButtonMenuCmd(menu,"Full file list\t\tShow detail file list.",NULL,rpanel->current->list,FXIconList::ID_SHOW_DETAILS);
        new RButtonMenuCmd(menu,"Brief file list\t\tShow brief file list.",NULL,rpanel->current->list,FXIconList::ID_SHOW_MINI_ICONS);
        new RButtonMenuCmd(menu,"Big icons\t\tShow big icons.",NULL,rpanel->current->list,FXIconList::ID_SHOW_BIG_ICONS);
        new FXMenuSeparator(menu);
        new RButtonMenuCmd(menu,"Rows\t\tView row-wise.",NULL,rpanel->current->list,FXIconList::ID_ARRANGE_BY_ROWS);
        new RButtonMenuCmd(menu,"Columns\t\tView column-wise.",NULL,rpanel->current->list,FXIconList::ID_ARRANGE_BY_COLUMNS);
        new FXMenuSeparator(menu);
        new RButtonMenuCmd(menu,"Name\t\tSort by file name.",NULL,rpanel->current->list,FXFileList::ID_SORT_BY_NAME);
        new RButtonMenuCmd(menu,"Type\t\tSort by file type.",NULL,rpanel->current->list,FXFileList::ID_SORT_BY_TYPE);
        new RButtonMenuCmd(menu,"Size\t\tSort by file size.",NULL,rpanel->current->list,FXFileList::ID_SORT_BY_SIZE);
        new RButtonMenuCmd(menu,"Time\t\tSort by modification time.",NULL,rpanel->current->list,FXFileList::ID_SORT_BY_TIME);
        if(!clipboard.empty())
        {
            new FXMenuSeparator(menu);
            new RButtonMenuCmd(menu,"Paste",NULL,lpanel->current,Panel::ID_PASTE_CLP);
        }
    }
    else // non empty selection
    {
        //FXIconItem** itemlist = lpanel->current->list->getSelectedItems();
        // file(s)
        if(lpanel->current->list->retrieveItem (itm) && lpanel->current->list->isItemFile(itm))
        {
            new RButtonMenuCmd(menu,"Open with...",NULL,lpanel->current,Panel::ID_OPEN_WITH);
            if(num == 1)
            {
              new RButtonMenuCmd(menu,"View",NULL,lpanel->current,Panel::ID_VIEW);
              new RButtonMenuCmd(menu,"Edit",NULL,lpanel->current,Panel::ID_EDIT);              
            }
        }

        new FXMenuSeparator(menu);
        new RButtonMenuCmd(menu,"Copy",NULL,lpanel->current,Panel::ID_COPY_CLP);
        new RButtonMenuCmd(menu,"Cut",NULL,lpanel->current,Panel::ID_CUT_CLP);
        if(!clipboard.empty())
            new RButtonMenuCmd(menu,"Paste",NULL,lpanel->current,Panel::ID_PASTE_CLP);
        new FXMenuSeparator(menu);
        new RButtonMenuCmd(menu,"Link",NULL,lpanel->current,Panel::ID_FILE_LINK);
        new RButtonMenuCmd(menu,"Symbolic link",NULL,lpanel->current,Panel::ID_FILE_SLINK);
        new RButtonMenuCmd(menu,"Delete",NULL,lpanel->current,Panel::ID_FILE_DEL);
        new FXMenuSeparator(menu);
        new RButtonMenuCmd(menu,"Attributes",attricon,lpanel->current,Panel::ID_ATTRIB);

        //delete[]itemlist;
    }
    menu->create();
    menu->popup(NULL,x,y);
    return 1;
}

long FDAppMainWindow::onCmdOptions(FXObject *o,FXSelector s,void *p)
{
  getApp ()->reg ().write ();
  preferencesDialog->execute ();
  
  return 1;
}

long FDAppMainWindow::onCmdOptionsChanged(FXObject *o,FXSelector s,void *p)
{
  getApp ()->reg ().read ();

  if (getApp()->reg().readUnsignedEntry("OPTIONS","toolbar", true))
    toolbar->handle (this, MKUINT (FXWindow::ID_SHOW, SEL_COMMAND), NULL);
  else toolbar->handle (this, MKUINT (FXWindow::ID_HIDE, SEL_COMMAND), NULL);

  if (getApp()->reg().readUnsignedEntry("OPTIONS","two_panels", false))
    rpanel->handle (this, MKUINT (FXWindow::ID_SHOW, SEL_COMMAND), NULL);
  else rpanel->handle (this, MKUINT (FXWindow::ID_HIDE, SEL_COMMAND), NULL);

  if (getApp()->reg().readUnsignedEntry("OPTIONS","statusbar", true))
  {
    lpanel->status->handle (this, MKUINT (FXWindow::ID_SHOW, SEL_COMMAND), NULL);
    rpanel->status->handle (this, MKUINT (FXWindow::ID_SHOW, SEL_COMMAND), NULL);
    lab->handle (this, MKUINT (FXWindow::ID_SHOW, SEL_COMMAND), NULL);
  }
  else
  {
    lpanel->status->handle (this, MKUINT (FXWindow::ID_HIDE, SEL_COMMAND), NULL);
    rpanel->status->handle (this, MKUINT (FXWindow::ID_HIDE, SEL_COMMAND), NULL);
    lab->handle (this, MKUINT (FXWindow::ID_HIDE, SEL_COMMAND), NULL);
  }

  if (getApp()->reg().readUnsignedEntry("OPTIONS","show_tree", true))
    group1->handle (this, MKUINT (FXWindow::ID_SHOW, SEL_COMMAND), NULL);
  else group1->handle (this, MKUINT (FXWindow::ID_HIDE, SEL_COMMAND), NULL);

  if (getApp()->reg().readUnsignedEntry("OPTIONS","hidden_files", false))
  {
    dirlist->handle (this, MKUINT (FXDirList::ID_SHOW_HIDDEN, SEL_COMMAND), NULL);
    rpanel->list->handle (this, MKUINT (FXFileList::ID_SHOW_HIDDEN, SEL_COMMAND), NULL);
    lpanel->list->handle (this, MKUINT (FXFileList::ID_SHOW_HIDDEN, SEL_COMMAND), NULL);
    hideButton->setState (true);
  }
  else
  {
    dirlist->handle (this, MKUINT (FXDirList::ID_HIDE_HIDDEN, SEL_COMMAND), NULL);
    rpanel->list->handle (this, MKUINT (FXFileList::ID_HIDE_HIDDEN, SEL_COMMAND), NULL);
    lpanel->list->handle (this, MKUINT (FXFileList::ID_HIDE_HIDDEN, SEL_COMMAND), NULL);
    hideButton->setState (false);
  }

  return 1;
}


long FDAppMainWindow::onCmdHideTree (FXObject *o,FXSelector s,void *p)
{
  group1->handle (this, MKUINT (FXWindow::ID_HIDE, SEL_COMMAND), NULL);
  getApp()->reg().writeUnsignedEntry("OPTIONS","show_tree", false);
}

long FDAppMainWindow::onCmdToggleHidden (FXObject *o,FXSelector s,void *p)
{
  getApp()->reg().writeUnsignedEntry("OPTIONS","hidden_files",
                       !getApp()->reg().readUnsignedEntry("OPTIONS","hidden_files", false));
  getApp ()->reg ().write ();
  onCmdOptionsChanged (o, s, p);
}

// Change the directory
long FDAppMainWindow::onCmdDirectory(FXObject*,FXSelector,void* ptr)
{
    FXTreeItem *item=(FXTreeItem*)ptr;
    if(item)
    {
        FXString directory = dirlist->getItemPathname(item);
        if(access(directory.text(),R_OK|X_OK))
        {
            FXMessageBox::error(this,MBOX_OK,"error", " Permission to: %s denied.", directory.text());
            return 0;
        }
        lpanel->current->list->setDirectory(directory);
    }
    return 1;
}

long FDAppMainWindow::onCmdDirBox(FXObject *o,FXSelector s,void *p)
{
    lpanel->current->list->setDirectory(dirbox->getDirectory());
    dirlist->setDirectory(dirbox->getDirectory());
    lpanel->current->list->setFocus();
    return 1;
}
long FDAppMainWindow::onUpdDirBox(FXObject *o,FXSelector s,void *p)
{
    FXString dir = lpanel->current->list->getDirectory();
    dirbox->setDirectory(dir);
    if(!rpanel->shown())
    {
        if(rmenutitle->shown())
        {
            lpanel->focus();
            rmenutitle->hide();
            lmenutitle->setText("List");
            lpanel->focus();
        }
    }
    else
    {
        if(!rmenutitle->shown())
        {
            rmenutitle->show();
            lmenutitle->setText("Left");
            lpanel->focus();
        }
    }
    return 1;
}

long FDAppMainWindow::onCmdFileAssoc(FXObject *o,FXSelector s,void *p)
{
   char* ext = (char*)p;
   FXFileDict *associations = lpanel->list->getAssociations();
   associations->remove(ext);
   
   associations = rpanel->list->getAssociations();
   associations->remove(ext);

   return 1;
}

/*******************************************************************************/
/* Run X program */
long FDAppMainWindow::onCmdRun(FXObject*,FXSelector,void*)
{
    int i;
    chdir(lpanel->current->list->getDirectory().text());
    HInputDialog* dialog;
    FXString command="";
    dialog = new HInputDialog(getApp(),command,"Execute Command :","Run");
    dialog->CursorEnd();
    for(int i=0;i<RunHistSize;i++)
        dialog->appendItem(RunHistory[i]);
    if(dialog->execute())
    {
        command=dialog->getText();
        if(command != "")
        {
            command+=" &";
            system(command.text());
        }
        RunHistSize=dialog->getHistorySize();
        RunHistSize++;
        command=dialog->getText();
        if(RunHistSize>RUN_HIST_SIZE)
            RunHistSize=RUN_HIST_SIZE;
        for(i=0;i<RunHistSize-1;i++)
            if(!strcmp(RunHistory[i],command.text()))
                break;
        if(i==RunHistSize-1)
        {
            strcpy(RunHistory[0],command.text());
            for(i=1;i<RunHistSize;i++)
            strcpy(RunHistory[i],dialog->getHistoryItem(i-1).text());
        }
        else
            RunHistSize--;
    }
    delete dialog;
    lpanel->current->list->setFocus();
    return 1;
}
/* Copy/Move/Rename/Link/SymLink File(s) */
long FDAppMainWindow::onCmdFileCopy(FXObject* ob,FXSelector sel,void* ptr)
{
    clipboard = "";

    lpanel->current->list->setFocus();
    FXchar path[MAXPATHLEN+1],name[2048],dir[MAXPATHLEN+1];
    FXString command,message,title,buf,error,target,sources;

    char *str = (char*)ptr;
    char *p = strchr(str,'\n');
    if(!p)
        return 0;
    *p++ = '\0';
    target = str;

    str = p;
    p = strchr(str,'\n');
    if(!p)
        return 0;
    *p++ = '\0';
    int num = atoi(str);
    sources = p;

    const unsigned char *ic=::copy_big;
    FXIcon *icon=NULL;
    chdir(target.text());
    char **args=NULL;
    if(num==0)return 0;//no selected files 
    args = new char*[num+3];
    args[num+1]=new char[MAXPATHLEN+1];//destination
    args[num+2]=NULL;//trailing '\0'

    int i;
    if(SELID(sel)==ID_FILE_COPY)
    {
      command="cp -a";
      title="Copy";
      ic=::copy_big;
    }
    if(SELID(sel)==ID_FILE_LINK)
    {
      command="ln";
      title="Link";
      ic=link_big;
    }
    if(SELID(sel)==ID_FILE_SLINK)
    {
      command="ln -s";
      title="SymLink";
      ic=link_big;
    }
    if(SELID(sel)==ID_FILE_MOVE)
    {
        command="mv";
        ic=move_big;
    }
   args[0]=new char[strlen(command.text())+1];
   strcpy(args[0],command.text());

   for(i=0;i<num ;i++)
   {
       strcpy(name,sources.extract(i,'\n').text());
       args[i+1]=new char[strlen(name)+1];
       strcpy(args[i+1],name);
   }

   strcpy(path,sources.extract(0,'\n').text());
   p = strrchr(path,'/');
   if(p)
   {
       *p++ = '\0';
       strcpy(name,p);
       strcpy(dir,path);
   }
   else
   {
       dir[0] = '\0';
       strcpy(name,path);
   }

   buf = target;
   if(buf!="/") buf+="/";
   // if we have permission to write
   if(access(buf.text(), W_OK))
   {
       FXMessageBox::error(this,MBOX_OK,"error", "Can't write to %s: Permission denied", buf.text());
       return 0;
   }

    if(SELID(sel)==ID_FILE_COPY)
    {
    	if(num==1)
	{
            message="Copy ";
	    message+=sources.extract(0,'\n');
	    buf+=name;
	}
	else
            message="Copy "+FXStringVal(num)+" files/folders.\nFrom: "+dir;
   }
    if(SELID(sel)==ID_FILE_MOVE)
    {
       title="Move";
       if(num==1)
       {
          message="Move ";
          message+=sources.extract(0,'\n');
          buf+=name;
          title="Move/Rename";
       }
	else
            message="Move "+FXStringVal(num)+" files/folders.\nFrom: "+dir;
     }
	
    if(SELID(sel)==ID_FILE_SLINK)
    {
       if(num==1)
       {
          message="SymLink ";
          message+=sources.extract(0,'\n');
          buf+=name;
       }
	else
            message="SymLink "+FXStringVal(num)+" files/folders.\nFrom: "+dir;
     }

    if(SELID(sel)==ID_FILE_LINK)
    {
       if(num==1)
       {
          message="Link ";
          message+=sources.extract(0,'\n');
          buf+=name;
       }
	else
            message="Link "+FXStringVal(num)+" files/folders.\nFrom: "+dir;
    }
   
    icon = new FXGIFIcon(getApp(),ic);
    bool rc=true;

    // Ask before copy
    if(getApp()->reg().readUnsignedEntry("OPTIONS","ask_before_copy",TRUE))
      rc = FXInputDialog::getString (buf, this, title, message, icon);

    // Run xcp
    if(rc)
    {
      strcpy(args[num+1],buf.text());
      
      lpanel->xcp (num+2, args);
    }
    for(i=0;args[i]!=NULL;i++)
      delete args[i];
    delete icon;
    delete[]args;    
    return 1;
}

