/* foXcommander - foXdesktop file manager
 * Copyright (C) 2000-2001 Josua Groeger derived from XWC (C) 1999-2000 Maxim Baranov
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include <fox/fx.h>
#include <fox/fxkeys.h>
#include "HistInputDialog.h"

// Object implementation
FXIMPLEMENT(MyComboBox,FXComboBox,NULL,0)

MyComboBox::MyComboBox(FXComposite *p,FXint cols,FXint nvis,FXObject* tgt,FXSelector sel,FXuint opts):
    FXComboBox(p,cols,nvis,tgt,sel,opts)
{}
FXDEFMAP(HInputDialog) HInputDialogMap[]={
  FXMAPFUNC(SEL_KEYPRESS,0,HInputDialog::onCmdKeyPress),  
};
// Object implementation
FXIMPLEMENT(HInputDialog,FXDialogBox,HInputDialogMap,ARRAYNUMBER(HInputDialogMap))

// Construct a dialogue box
HInputDialog::HInputDialog(FXApp* app,FXString& inp,FXString message,FXString title,FXString label,FXIcon *ic):
  FXDialogBox(app,title,DECOR_TITLE|DECOR_BORDER)
{
    /* Buttons */
    buttons=new FXHorizontalFrame(this,PACK_UNIFORM_WIDTH|LAYOUT_SIDE_BOTTOM|LAYOUT_FILL_X,0,0,0,0,10,10,5,5);
    /* Cancel */
    new FXButton(buttons,"&Cancel",NULL,this,ID_CANCEL,FRAME_RAISED|FRAME_THICK|LAYOUT_RIGHT,0,0,0,0,20,20);
    /* Accept */
    new FXButton(buttons,"&Accept",NULL,this,ID_ACCEPT,FRAME_RAISED|FRAME_THICK|LAYOUT_RIGHT,0,0,0,0,20,20);
    /* Separator */
    new FXHorizontalSeparator(this,LAYOUT_SIDE_BOTTOM|LAYOUT_FILL_X|SEPARATOR_GROOVE);

    FXMatrix *matrix = new FXMatrix(this,2,MATRIX_BY_COLUMNS|LAYOUT_SIDE_TOP|LAYOUT_FILL_X|LAYOUT_FILL_Y);
    // Icon
    new FXLabel(matrix,"",ic,LAYOUT_CENTER_Y|LAYOUT_FILL_COLUMN|LAYOUT_FILL_ROW);
    // Message
    new FXLabel(matrix,message,NULL,JUSTIFY_LEFT|LAYOUT_CENTER_Y|LAYOUT_FILL_COLUMN|LAYOUT_FILL_ROW);

    // Label
    new FXLabel(matrix,label,NULL,LAYOUT_RIGHT|LAYOUT_CENTER_Y|LAYOUT_FILL_COLUMN|LAYOUT_FILL_ROW);
    // Input Field
    input = new MyComboBox(matrix,30,5,NULL,0,COMBOBOX_NO_REPLACE/*COMBOBOX_INSERT_LAST*/|FRAME_SUNKEN|FRAME_THICK|LAYOUT_SIDE_TOP);
    input->setText(inp);
}
void HInputDialog::create()
{
   FXDialogBox::create();
//   input->setFocus();
}
void HInputDialog::CursorEnd()
{
   input->Focus();
//    input->getTextEntry()->setFocus();
//    input->onFwdToText(this,MKUINT(FXTextField::ID_CURSOR_END,SEL_COMMAND),NULL);
//    input->onFwdToText(this,MKUINT(0,SEL_FOCUSIN),NULL);
}
void HInputDialog::SelectAll()
{
    input->onFwdToText(this,MKUINT(0,SEL_FOCUSIN),NULL);
    input->onFwdToText(this,MKUINT(FXTextField::ID_SELECT_ALL,SEL_COMMAND),NULL);
    return;
}

long HInputDialog::onCmdKeyPress(FXObject*,FXSelector,void* ptr)
{
	FXEvent* event=(FXEvent*)ptr;
	input->handle(this,MKUINT(message,SEL_KEYPRESS),ptr); 
	 switch(event->code)
	 {
	 	case KEY_Escape:	handle(this,MKUINT(ID_CANCEL,SEL_COMMAND),NULL);
							 return 1;
		case KEY_KP_Enter:
		case KEY_Return:	
							 handle(this,MKUINT(ID_ACCEPT,SEL_COMMAND),NULL);
							 return 1;
		default:		  return 1;
	 	
	 }	
}

