/* foXcommander - foXdesktop file manager
 * Copyright (C) 2000-2001 Josua Groeger derived from XWC (C) 1999-2000 Maxim Baranov
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include <fox/xincs.h>
#include <fox/fx.h>
#include <fox/fxkeys.h>
#include "Attributes.h"
#include "Panel.h"
#include "FDAppMainWindow.h"
#include "HistInputDialog.h"
#include "icons.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/wait.h>
#include "fcntl.h"


#include <iostream.h>

#define OPEN_WITH_HIST_SIZE 30
char OpenHistory[OPEN_WITH_HIST_SIZE][100];
int OpenNum;

FXString clipboard = "";

/* Global Variables */
int delete_flag=0;
FXString homelocation;

// Global Flags
extern int Size(FXchar* size,FXchar *newsize);
#if defined(linux)
extern FXStringDict*      devices;
#endif

/**********************************************************************/
/* Map */
FXDEFMAP(Panel) PanelMap[]={
  FXMAPFUNC(SEL_RIGHTBUTTONPRESS,Panel::ID_ATTRIB,Panel::onCmdAttrib),
  FXMAPFUNC(SEL_DOUBLECLICKED,Panel::ID_FILE_PANEL,Panel::onCmdItemDblClcked),
  FXMAPFUNC(SEL_UPDATE,Panel::ID_STATUS,Panel::onUpdStatus),
  FXMAPFUNC(SEL_UPDATE,Panel::ID_LABEL,Panel::onUpdLabel),
  FXMAPFUNC(SEL_RIGHTBUTTONPRESS,Panel::ID_FILE_PANEL,Panel::onPopupMenu),
  FXMAPFUNC(SEL_CLICKED,Panel::ID_FILE_PANEL,Panel::onCmdItemClcked),
  FXMAPFUNC(SEL_COMMAND,Panel::ID_DIRECTORY_UP,Panel::onCmdDirectoryUp),
  FXMAPFUNC(SEL_UPDATE,Panel::ID_DIRECTORY_UP,Panel::onUpdUp),
  FXMAPFUNC(SEL_COMMAND,Panel::ID_FILTER,Panel::onCmdItemFilter),
  FXMAPFUNC(SEL_COMMAND,Panel::ID_GO_HOME,Panel::onCmdGoHome),
  FXMAPFUNC(SEL_UPDATE,Panel::ID_GO_HOME,Panel::onUpdHome),
  FXMAPFUNC(SEL_COMMAND,Panel::ID_VIEW,Panel::onCmdEdit),
  FXMAPFUNC(SEL_COMMAND,Panel::ID_EDIT,Panel::onCmdEdit),
  FXMAPFUNC(SEL_COMMAND,Panel::ID_ATTRIB,Panel::onCmdAttrib),
  FXMAPFUNC(SEL_UPDATE,Panel::ID_ATTRIB,Panel::onUpdFileButtons),
  FXMAPFUNC(SEL_COMMAND,Panel::ID_NEW_DIR,Panel::onCmdNewDir),
  FXMAPFUNC(SEL_UPDATE,Panel::ID_NEW_DIR,Panel::onUpdButton),
  FXMAPFUNC(SEL_COMMAND,Panel::ID_FILE_COPY,Panel::onCmdFile),
  FXMAPFUNC(SEL_UPDATE,Panel::ID_COPY_CLP,Panel::onUpdFileButtons),
  FXMAPFUNC(SEL_COMMAND,Panel::ID_COPY_CLP,Panel::onCmdClp),
  FXMAPFUNC(SEL_COMMAND,Panel::ID_FILE_MOVE,Panel::onCmdFile),
  FXMAPFUNC(SEL_UPDATE,Panel::ID_CUT_CLP,Panel::onUpdFileButtons),
  FXMAPFUNC(SEL_COMMAND,Panel::ID_CUT_CLP,Panel::onCmdClp),
  FXMAPFUNC(SEL_COMMAND,Panel::ID_PASTE_CLP,Panel::onCmdPaste),
  FXMAPFUNC(SEL_UPDATE,Panel::ID_PASTE_CLP,Panel::onUpdPaste),
  FXMAPFUNC(SEL_COMMAND,Panel::ID_FILE_DEL,Panel::onCmdFileDel),
  FXMAPFUNC(SEL_UPDATE,Panel::ID_FILE_DEL,Panel::onUpdButton),
  FXMAPFUNC(SEL_COMMAND,Panel::ID_FILE_LINK,Panel::onCmdFile),
  FXMAPFUNC(SEL_COMMAND,Panel::ID_FILE_SLINK,Panel::onCmdFile),
  FXMAPFUNC(SEL_COMMAND,Panel::ID_OPEN_WITH,Panel::onCmdOpenWith),
  FXMAPFUNC(SEL_COMMAND,Panel::ID_REFRESH,Panel::onRefresh),
  FXMAPFUNC(SEL_UPDATE,Panel::ID_REFRESH,Panel::onUpdButton),
#if defined(linux)
  FXMAPFUNC(SEL_KEYPRESS,0,Panel::onCmdKeyPress),
#endif
 };
/* Object implementation */
FXIMPLEMENT(Panel,FXVerticalFrame,PanelMap,ARRAYNUMBER(PanelMap))

/* Construct File Panel */
Panel::Panel(FXchar* nm,FXComposite *p): FXVerticalFrame(p,LAYOUT_FILL_Y|LAYOUT_FILL_X, 0,0,0,0, 0,0,0,0)
{
   name=nm;
//   app=getApp();
   label=new FXLabel(this," ",NULL,JUSTIFY_LEFT|LAYOUT_LEFT|LAYOUT_FILL_X|FRAME_SUNKEN);
   label->setTarget(this);
   label->setSelector(MKUINT(Panel::ID_LABEL,0));

   FXVerticalFrame* cont=new FXVerticalFrame(this,LAYOUT_FILL_Y|LAYOUT_FILL_X|FRAME_SUNKEN|FRAME_THICK ,0,0,0,0,0,0,0,0);
   status=new FXLabel(this,"Status.",NULL,JUSTIFY_LEFT|LAYOUT_LEFT|LAYOUT_FILL_X|FRAME_SUNKEN);
   status->setTarget(this);
   status->setSelector(MKUINT(Panel::ID_STATUS,SEL_UPDATE));

   list=new FXFileList(cont,this,ID_FILE_PANEL,/*ICONLIST_WANTSELECTION|*/LAYOUT_FILL_X|LAYOUT_FILL_Y|FRAME_SUNKEN|ICONLIST_BIG_ICONS);

   homelocation=getenv("HOME");
   if(homelocation=="") homelocation="/";
}
// Destructor
Panel::~Panel()
{
    delete list;
    delete label;
}

/**************************************************/
/* Panel Gets Focus */
void Panel::focus()
{
    if(this == current)
        return;
    label->setBackColor(FXRGB(25,25,112));
    label->setTextColor(FXRGB(255,255,255));
    current=this;
    next->unfocus();
    list->setFocus();
    ((FDAppMainWindow*) getApp()->getMainWindow())->dirlist->setDirectory(current->list->getDirectory());
}
/**************************************************/
/* Panel Loses Focus*/
void Panel::unfocus()
{
    label->setBackColor(FXRGB(160,160,160));
    label->setTextColor(FXRGB(255,255,255));
    current=next;
    list->handle(this,MKUINT(FXFileList::ID_DESELECT_ALL,SEL_COMMAND),NULL);
}
/**************************************************/
/* Set Pointer to Another Panel*/
void Panel::Next(Panel* nxt)
{
	next=nxt;
}
long Panel::onCmdKeyPress(FXObject* o,FXSelector sel,void* ptr)
{
    int item;
    FXEvent* event=(FXEvent*)ptr;
    switch(event->code)
    {
    case KEY_Tab:
        if(shown() && next->shown())
            current->next->focus();
        return 1;
    case KEY_a:
        if(event->state&CONTROLMASK)
            current->list->handle(o,MKUINT(FXFileList::ID_SELECT_ALL,SEL_COMMAND),ptr);
        FXWindow::onKeyPress(o,sel,ptr);
        return 1;
    case KEY_Insert:
        item = current->list->getCurrentItem();
        if(item> -1)
        {
            if(current->list->getItemText(item).extract(0,'\t') != "..")
            {
                current->list->toggleItem(item);
            }
            
            item++;
            if(current->list->retrieveItem(item))
            {
                current->list->setCurrentItem(item);
                current->list->makeItemVisible(item);
            }
        }
        return 1;
    case KEY_F3:
//        if(shown() && next->shown())
            handle(o,MKUINT(Panel::ID_VIEW,SEL_COMMAND),ptr);
        return 1;
    case KEY_F4:
//        if(shown() && next->shown())
            handle(o,MKUINT(Panel::ID_EDIT,SEL_COMMAND),ptr);
        return 1;
    case KEY_F5:
        if(shown() && next->shown())
            handle(o,MKUINT(Panel::ID_FILE_COPY,SEL_COMMAND),ptr);
        return 1;
    case KEY_F6:
        if(shown() && next->shown())
            handle(o,MKUINT(Panel::ID_FILE_MOVE,SEL_COMMAND),ptr);
        return 1;
    default:
             FXWindow::onKeyPress(o,sel,ptr);

             FXAccelTable *accel; FXWindow *win=this;
             while((accel=win->getAccelTable())==NULL && win!=getShell())
                 win=win->getParent();
             if(accel)
                 accel->handle(this,sel,ptr);

             return 1;
    }
}

/*************************************************/
/* Double Click on File Item */
long Panel::onCmdItemDblClcked(FXObject* sender,FXSelector sel, void* ptr)
{
    chdir(current->list->getDirectory().text());
    FXchar path[MAXPATHLEN+1],name[2048],dir[MAXPATHLEN+1],*p;
    FXString buf;
  
  /*
    FXIconItem *_item=(FXIconItem*)ptr;
    int item= -1;
    for (int u= 0; u< list->getNumItems (); u++)
      if (_item== list->retrieveItem (u))
      {
        item= u;
        break;
      }
     */
   
   int item= (int) ptr;
  
    if(item> -1)
    {
        strcpy(name,list->getItemText(item).text());      //// FIX
        if((p=strchr(name,'\t'))) *p=0;
        strcpy(path,list->getDirectory().text());         //// FIX
        fxpathname(dir,path,name);

        /* If directory, open the directory */
        if(list->isItemDirectory(item))
        {
            if(access(dir,R_OK|X_OK))
                return 0;//does not have access
            if(dir[0]=='.' && dir[1]=='.' && dir[2]==0)// '..'  ?
                list->handle(this,MKUINT(FXFileList::ID_DIRECTORY_UP,SEL_COMMAND),NULL);
            else
                list->setDirectory(dir);
            ((FDAppMainWindow*) getApp()->getMainWindow())->dirlist->setDirectory(dir);
        }
        else if(list->isItemFile(item)){
            FXFileAssoc *association=list->getItemAssoc(item);
            if(association)
                if(association->command.extract(0,',').text() != NULL)
                {
                    FXString command=association->command.extract(0,',')+" \""+list->getItemPathname(item);
                    command+="\" &";
                    system(command.text());
                }
                else if(list->isItemExecutable(item))/*executable*/
                {
                    buf="'";
                    buf+=dir;
                    buf+="' &";
                    system(buf.text());
                }    // If regular file return as the selected file
                else
                    current->handle(this,MKUINT(ID_OPEN_WITH,SEL_COMMAND),NULL);
                
            else if(list->isItemExecutable(item))/*executable*/
            {
                buf="'";
                buf+=dir;
                buf+="' &";
                system(buf.text());
            }    // If regular file return as the selected file
            else
                current->handle(this,MKUINT(ID_OPEN_WITH,SEL_COMMAND),NULL);
            
        }
    }
    return 1;
}/*************************************************/
long Panel::onCmdItemClcked(FXObject* sender,FXSelector sel, void* ptr)
{
    focus();
    return 1;
}/*************************************************/
long Panel::onCmdDirectoryUp(FXObject* sender,FXSelector sel, void* ptr)
{
   current->list->handle(this,MKUINT(FXFileList::ID_DIRECTORY_UP,SEL_COMMAND),NULL);
   current->list->setFocus();
   ((FDAppMainWindow*) getApp()->getMainWindow())->dirlist->setDirectory(current->list->getDirectory());
   return 1;
}/*************************************************/
long Panel::onCmdGoHome(FXObject* sender,FXSelector sel, void* ptr)
{
    current->list->setDirectory(homelocation);
    current->list->setFocus();
    ((FDAppMainWindow*) getApp()->getMainWindow())->dirlist->setDirectory(homelocation);
    return 1;
}/*************************************************/

/*************************************************/
/* Copy/Move/Rename/Link/SymLink Delete File(s) */
long Panel::onCmdFile(FXObject* ob,FXSelector sel,void*)
{
    FXString target,sources,name,curdir,param;
    //int num;
    curdir = current->list->getDirectory();

    //num = current->list->getNumSelectedItems();

    
    int num= 0, itm= -1;
    int dotdot = 0;
    for (int u= 0; u< current->list->getNumItems (); u++)
      if (current->list->isItemSelected (u))
      {
        if (itm== -1) itm= u;
        num++;
        
        name = current->list->getItemText(u).text();
        name = name.extract(0,'\t');
        if(name == "..")
        {
            dotdot = 1;
            continue;
        }
        sources += curdir+"/"+name+"\n";
      }
    
    if(dotdot)
        num--;

    target = current->next->list->getDirectory();
    if(!current->next->shown())
        target = current->list->getDirectory();

    if(SELID(sel)!= ID_FILE_DEL)
        param = target+"\n"+FXStringVal(num)+"\n"+sources;
    else
        param = FXStringVal(num)+"\n"+sources;
       
    switch(SELID(sel))
    {
    case ID_FILE_COPY:
        sel = MKUINT(FDAppMainWindow::ID_FILE_COPY,SEL_COMMAND);
        break;
    case ID_FILE_MOVE:
        sel = MKUINT(FDAppMainWindow::ID_FILE_MOVE,SEL_COMMAND);
        break;
    case ID_FILE_LINK:
        sel = MKUINT(FDAppMainWindow::ID_FILE_LINK,SEL_COMMAND);
        break;
    case ID_FILE_SLINK:
        sel = MKUINT(FDAppMainWindow::ID_FILE_SLINK,SEL_COMMAND);
        break;
    case ID_FILE_DEL:
        sel = MKUINT(FDAppMainWindow::ID_FILE_DEL,SEL_COMMAND);
        break;
    }
    getApp()->getMainWindow()->handle(this,sel,(char*)param.text());
    return 1;
}
/* Delete File(s) */
long Panel::onCmdFileDel(FXObject*,FXSelector,void*)
{
    current->list->setFocus();
    chdir(current->list->getDirectory().text());
    FXchar name[2048],*p;

    FXString buf=current->list->getDirectory();
    /* if we have permission to write */
    if(access(buf.text(), W_OK))
    {
       FXMessageBox::error(this,MBOX_OK,"error", "Can't write to %s: Permission denied", buf.text());
       return 0;
    }         

    char **args=NULL;
    
    
    int num= 0;
    for (int u= 0; u< current->list->getNumItems (); u++)
      if (current->list->isItemSelected (u)) num++;
    
    if(num==0)return 0;//no files to delete

    if(getApp()->reg().readUnsignedEntry("OPTIONS","confirm_delete",TRUE))
    {
      
        FXGIFIcon icon(getApp(),delete_big);
        FXMessageBox box(this,"Confirm Delete","  Delete All Selected Items ?  ",&icon,MBOX_YES_NO|DECOR_TITLE|DECOR_BORDER);
        if(box.execute() != MBOX_CLICKED_YES)
            return 0;
    }

    args = new char*[num+2];
    args[num+1]=NULL;//trailing '\0'
    args[0]=new char[MAXPATHLEN+1];//command
    strcpy(args[0],"rm -r");

    
    int i= 0;
    for (int u= 0; u< current->list->getNumItems (); u++)
      if (current->list->isItemSelected (u))
      {
		strcpy(name,current->list->getItemText(u).text());      
		if((p=strchr(name,'\t'))) *p=0;                                             
		
		args[i+1]=new char[strlen(name)+1];
		strcpy(args[i+1],name);
        i++;
      }
      
    xcp (num+1, args);
      
	onRefresh(0,0,0);
	return 1;
}

/*************************************************/
long Panel::onCmdEdit(FXObject*,FXSelector s,void*)
{
    current->list->setFocus();
    chdir(current->list->getDirectory().text());
    FXchar path[MAXPATHLEN+1],name[2048],dir[MAXPATHLEN+1],*p;
    
    int num= 0, itm= -1;
    for (int u= 0; u< current->list->getNumItems (); u++)
      if (current->list->isItemSelected (u))
      {
        if (itm== -1) itm= u;
        num++;
      }
  
    FXString command;

    if(num == 1)
    {
        FXFileAssoc *association=current->list->getItemAssoc(itm);
        if(association)
        {
            if(SELID(s)==ID_EDIT)
            {
                command=association->command.extract(2,',');
                if(command.text() == NULL)
                    command = "";
            }else
            {
                command=association->command.extract(1,',');
                if(command.text() == NULL)
                    command = "";
            }
      }      
    }
    
    
    
    
    
    
    
    
    for (int u= 0; u< current->list->getNumItems (); u++)
      if (current->list->isItemSelected (u))
      {
        strcpy(name,current->list->getItemText(u).text());      //// FIX
        if((p=strchr(name,'\t'))) *p=0;
        strcpy(path,current->list->getDirectory().text());         //// FIX
        fxpathname(dir,path,name);
        command+=" \"";
        command+=dir;
        command+="\"";
        command+=" ";
      }

    
    command+=" &";
    system(command.text());
    return 1;
}
/*************************************************/
long Panel::onCmdAttrib(FXObject* sender,FXSelector,void*)
{
  
    current->list->setFocus();
    chdir(current->list->getDirectory().text());
  
    int num= 0, itm= -1;
    for (int u= 0; u< current->list->getNumItems (); u++)
      if (current->list->isItemSelected (u))
      {
        if (itm== -1) itm= u;
        num++;
      }

  
  
    FXString path=current->list->getDirectory();
    if(num==1)
    {
        FXString filename = current->list->getItemText(itm);
        filename=filename.extract(0,'\t');
        attrdlg = new FXAttributesBox(getApp(),filename,path);
        if(attrdlg->execute())
        {
            current->list->setDirectory("/");
            current->list->setDirectory(path);
        }
        else
            if(attrdlg->child()!=-1)
                kill(attrdlg->child(),2);
        delete attrdlg;
        return 1;
    }
    else if(num>1)
    {
        FXString *files = new FXString[num];

        
        int i= 0;
        for (int u= 0; u< current->list->getNumItems (); u++)
        if (current->list->isItemSelected (u))
        {
          files[i] = current->list->getItemText(u).extract(0,'\t');
          i++;
        }

        
        attrdlg = new FXAttributesBox(getApp(),files,num);
        if(attrdlg->execute())
        {
            current->list->setDirectory("/");
            current->list->setDirectory(path);
        }
        delete attrdlg;
        delete[]files;
    }
    return 0;
}

long Panel::onCmdNewDir (FXObject*, FXSelector, void*)
{
  current->list->setFocus ();
  FXString cmd= "mkdir ";
  FXString dir= current->list->getDirectory ();

  FXString buf;
  if (FXInputDialog::getString (buf, this, "Create new folder", "New folder in \""+ dir+ "\":",
                                ((FDApp*) getApp ())->ico ().insert ("foXfolder.xpm")))
  {
    if (dir!= "/") dir+= "/";
    cmd+= dir+ buf+ " &";
    system (cmd.text ());
  }

  return 1;
}

long Panel::onCmdPaste(FXObject*,FXSelector sel,void*)
{
    if(clipboard.empty())
        return 1;

    FXString param;
    param = current->list->getDirectory()+"\n"+clipboard;
    switch(clp)
    {
    case ID_COPY_CLP:
        sel = MKUINT(FDAppMainWindow::ID_FILE_COPY,SEL_COMMAND);
        break;
    case ID_CUT_CLP:
        sel = MKUINT(FDAppMainWindow::ID_FILE_MOVE,SEL_COMMAND);
        break;
    }
    getApp()->getMainWindow()->handle(this,sel,(char*)param.text());
    clipboard = "";
    return 1;
}
long Panel::onCmdClp(FXObject*,FXSelector sel,void*)
{
    FXString name,curdir;
    

    clipboard = "";
    clp = SELID(sel);

  
  
  
  
    int num= 0;
    for (int u= 0; u< current->list->getNumItems (); u++)
      if (current->list->isItemSelected (u)) num++;

    if(num == 0)
        return 1;

    curdir = current->list->getDirectory();

    
    
    
    int dotdot = 0;
    for (int u= 0; u< current->list->getNumItems (); u++)
      if (current->list->isItemSelected (u))
      {
        name = current->list->getItemText(u).text();
        name = name.extract(0,'\t');
        if(name == "..")
        {
            dotdot = 1;
            continue;
        }
        clipboard += curdir+"/"+name+"\n";
    
      }

    clipboard = FXStringVal(num)+"\n"+clipboard;
    return 1;
}

/*************************************************/
long Panel::onCmdOpenWith(FXObject*,FXSelector,void*)
{
    current->list->setFocus();
    int i;
    chdir(current->list->getDirectory().text());
    
    
  
    int num= 0;
    for (int u= 0; u< current->list->getNumItems (); u++)
      if (current->list->isItemSelected (u)) num++;
    if(!num)return 0;
  
    FXchar path[MAXPATHLEN+1],name[2048],dir[MAXPATHLEN+1],*p;
    HInputDialog* dialog;
    FXString command="";
    dialog = new HInputDialog(getApp(),command,"Open selected file(s) with :","Open With");
    dialog->CursorEnd();
    for(int i=0;i<OpenNum;i++)
        dialog->appendItem(OpenHistory[i]);
    if(dialog->execute())
    {
        command=dialog->getText();
        
        
      
        
        for (int u= 0; u< current->list->getNumItems (); u++)
        if (current->list->isItemSelected (u))
        {
            strcpy(name,current->list->getItemText(u).text());      //// FIX
            if((p=strchr(name,'\t'))) *p=0;
            strcpy(path,current->list->getDirectory().text());         //// FIX
            fxpathname(dir,path,name);
            command+=" ";
            command=command+"\""+dir+"\"";
            command+=" ";
 
        }

      
        command+=" &";
        system(command.text());

        OpenNum=dialog->getHistorySize();
        OpenNum++;
        command=dialog->getText();
        if(OpenNum>OPEN_WITH_HIST_SIZE)
            OpenNum=OPEN_WITH_HIST_SIZE;
        for(i=0;i<OpenNum-1;i++)
            if(!strcmp(OpenHistory[i],command.text()))
                break;
        if(i==OpenNum-1)
        {
            strcpy(OpenHistory[0],command.text());
            for(i=1;i<OpenNum;i++)
                strcpy(OpenHistory[i],dialog->getHistoryItem(i-1).text());
        }
        else
            OpenNum--;
    }
    delete dialog;
    return 1;
}
/**************************************************/
long Panel::onCmdItemFilter(FXObject*,FXSelector,void*)
{
    current->list->setFocus();
#define FILTER_HIST_SIZE 15
    static char history[FILTER_HIST_SIZE][100];
    static int no=7;
    strcpy(history[0],"*");
    strcpy(history[1],"*.txt");
    strcpy(history[2],"*.cpp");
    strcpy(history[3],"*.h");
    strcpy(history[4],"*.html");
    strcpy(history[5],"*.gif");
    strcpy(history[6],"*.xpm");
    int i;
    HInputDialog* dialog;
    FXString pat=list->getPattern();
    dialog = new HInputDialog(getApp(),pat,"Show files :","Filter");
    dialog->CursorEnd();
    dialog->SelectAll();
    for(int i=0;i<no;i++)
        dialog->appendItem(history[i]);

	if(dialog->execute() && (pat = dialog->getText()) != "")
	{
            list->setPattern(pat);
            no=dialog->getHistorySize();
            no++;
            if(no>FILTER_HIST_SIZE)
                no=FILTER_HIST_SIZE;

            for(i=0;i<no-1;i++)
                if(!strcmp(history[i],pat.text()))
                    break;
            if(i==no-1)
            {
                strcpy(history[0],pat.text());
                for(i=1;i<no;i++)
                    strcpy(history[i],dialog->getHistoryItem(i-1).text());
            }
            else
                no--;
	}
	delete dialog;

	return 1;
}
/******************************************************************************/
long Panel::onUpdStatus(FXObject*,FXSelector,void*)
{
    int st;
    if(waitpid(0,&st,WNOHANG)>0);

    
	int item= -1;
	FXString str,path,name,ext,size,perm,usr,grp;
	path=list->getDirectory();
	FXchar buf[MAXPATHLEN+1],*p,*file;
	
    
    
    int num= 0;
    for (int u= 0; u< list->getNumItems (); u++)
      if (list->isItemSelected (u)) num++;
	
    
    item = list->getCurrentItem();
	if(num>1)
        {
            
            FXchar newsize[50];
            long sz=0;
            size="0 bytes";
            
          
            for (int u= 0; u< list->getNumItems (); u++)
            if (list->isItemSelected (u))
            {
          
                if(!list->isItemDirectory(u))
                {
                    sz+=atol(list->getItemText(u).extract(2,'\t').text());
                    sprintf(newsize,"%dl",sz);
                    ::Size(newsize,newsize);
                    size=newsize;
                }
            }
            status->setText(size+" in "+FXStringVal(num)+" selected files");
            
	    return 0;
	}

	if(item<0)
        {
            num=list->getNumItems();
            status->setText(FXStringVal(num-1)+" Items");
        }
	else
	{
		strcpy(buf,(list->getItemText(item)).text());
		file=buf;
   	if((p=strchr(file,'\t'))) 
    	{
			*p=0;
			name=file;
			file=p+1;
    	}
    	if((p=strchr(file,'\t'))) 
    	{
			*p=0;
			ext=file;
			file=p+1;
    	}
		if((p=strchr(file,'\t')))
		{
			*p=0;
			size=file;
			file=p+1;
		}
		if((p=strchr(file,'\t')))
		{
			*p=0;
			file=p+1;
		}
		if((p=strchr(file,'\t')))
		{
			*p=0;
			usr=file;
			file=p+1;
		}
		if((p=strchr(file,'\t')))
		{
			*p=0;
			grp=file;
			perm=p+1;
		}
		if(strstr(ext.text(),"Link"))
		{
			FXint nread;
			
			nread=readlink((path+"/"+name).text(),buf,sizeof(buf)-1);
			if(nread>0)
			{
				buf[nread]='\0';
				status->setText(name+" -> "+buf);
			}			
		}else
		{
  			FXchar newsize[50];
			::Size((char*)size.text(),newsize);
			size=newsize;			
			status->setText(usr+","+grp+" "+perm+" ("+size+") "/*+name*/);
		}
	
	}
	return 1;
}
/**************************************************/
long Panel::onUpdLabel(FXObject*,FXSelector,void*)
{
    char directory[MAXPATHLEN+1];
    register char *dir = directory;
    strcpy(dir,list->getDirectory().text());
    FXFont *normalFont = getApp()->getNormalFont ();
    register int len = strlen(dir);
    register int text_width = normalFont->getTextWidth(dir,len);
    int lbl_width = label->getWidth();

    while((text_width > lbl_width) && len)
    {
        dir++;
        len--;
        dir[0] = '.';
        dir[1] = '.';
        dir[2] = '.';
        text_width = normalFont->getTextWidth(dir,len);
    }
    label->setText(dir);
    return 1;
}
/**************************************************/
long Panel::onPopupMenu(FXObject* o,FXSelector s,void* p)
{
   focus();
   int num= 0;
   for (int u= 0; u< list->getNumItems (); u++)
     if (list->isItemSelected (u)) num++;
  
   if(num<=1)
   {
      FXint x,y; FXuint state;
      list->getCursorPosition(x,y,state);
      int item=list->getItemAt(x,y);
      
      if (list->getCurrentItem ()>= 0) list->deselectItem(list->getCurrentItem());
      
      if (item>= 0)
      {
        list->setCurrentItem(item);
        list->selectItem(item);
      }
   }
   getApp()->getMainWindow()->handle(this,MKUINT(FDAppMainWindow::ID_MENU,SEL_COMMAND),(void*)list->getCurrentItem());
   return 1;
}
/**************************************************/
long Panel::onRefresh(FXObject*,FXSelector,void*)
{
    current->list->setFocus();
    FXString dir=current->list->getDirectory();
    current->list->setDirectory("/");
    current->list->setDirectory(dir);
    return 1;
}
/*******************************************************************************/
void Panel::xcp (int argc,char *argv[])
{
  // Caclulate the command string (e.g. cp -a /bla/fasel /foo/bar)
  FXString cmd;
  for (int i= 0; i< argc; i++)
  {
    cmd.append (argv[i]);
    cmd+= ' ';
  }

  // Calculate the xterm command string
  FXString xtermCmd (getApp ()->reg ().readStringEntry ("PROGRAM ALIASES", "xterm", fd_default_xterm));
  xtermCmd+= " -geometry 50x5 -title \"Executing "+ FXString (argv[0])+
             " ...\" -e sh -c \"echo "+ cmd+ " && "+ cmd+ "\" &";

  cerr<< cmd.text ()<< "\n";
  system (xtermCmd.text ());
}


/*******************************************************************************/

long Panel::onUpdHome(FXObject* o,FXSelector,void*)
{
//    getApp()->getMainWindow()->handle(o,MKUINT(FDAppMainWindow::ID_BUTTON_STYLE,SEL_UPDATE),NULL);
    return 1;
}
long Panel::onUpdUp(FXObject* o,FXSelector,void*)
{
    FXButton *button=(FXButton*)o;
    int style=button->getButtonStyle();
    if(style & BUTTON_TOOLBAR)
    {
        if(current->list->getDirectory()!="/")
            o->handle(this,MKUINT(FXWindow::ID_ENABLE,SEL_COMMAND),NULL);
        else
            o->handle(this,MKUINT(FXWindow::ID_DISABLE,SEL_COMMAND),NULL);
    }
    else
        o->handle(this,MKUINT(FXWindow::ID_ENABLE,SEL_COMMAND),NULL);
//    getApp()->getMainWindow()->handle(o,MKUINT(FDAppMainWindow::ID_BUTTON_STYLE,SEL_UPDATE),NULL);
    return 1;
}
long Panel::onUpdPaste(FXObject* o,FXSelector,void*)
{
    FXButton *button=(FXButton*)o;
    int style=button->getButtonStyle();
    if(style & BUTTON_TOOLBAR)
    {
        if(!clipboard.empty())
            o->handle(this,MKUINT(FXWindow::ID_ENABLE,SEL_COMMAND),NULL);
        else
            o->handle(this,MKUINT(FXWindow::ID_DISABLE,SEL_COMMAND),NULL);
    }
    else
        o->handle(this,MKUINT(FXWindow::ID_ENABLE,SEL_COMMAND),NULL);

//    getApp()->getMainWindow()->handle(o,MKUINT(FDAppMainWindow::ID_BUTTON_STYLE,SEL_UPDATE),NULL);
    return 1;
}

long Panel::onUpdFileButtons(FXObject* o,FXSelector,void*)
{
    FXButton *button=(FXButton*)o;
    int style=button->getButtonStyle();
    if(style & BUTTON_TOOLBAR)
    {
        
      
      
      int num= 0;
      for (int u= 0; u< current->list->getNumItems (); u++)
        if (current->list->isItemSelected (u)) num++;
      
      
        if(num)
            o->handle(this,MKUINT(FXWindow::ID_ENABLE,SEL_COMMAND),NULL);
        else
            o->handle(this,MKUINT(FXWindow::ID_DISABLE,SEL_COMMAND),NULL);
    }
    else
    o->handle(this,MKUINT(FXWindow::ID_ENABLE,SEL_COMMAND),NULL);

//    getApp()->getMainWindow()->handle(o,MKUINT(FDAppMainWindow::ID_BUTTON_STYLE,SEL_UPDATE),NULL);
    return 1;
}
long Panel::onUpdButton(FXObject* o,FXSelector,void*)
{
    FXButton *button=(FXButton*)o;
    int style=button->getButtonStyle();
    if(!(style & BUTTON_TOOLBAR))
        o->handle(this,MKUINT(FXWindow::ID_ENABLE,SEL_COMMAND),NULL);
//    getApp()->getMainWindow()->handle(o,MKUINT(FDAppMainWindow::ID_BUTTON_STYLE,SEL_UPDATE),NULL);
    return 1;
}

